/* * 版 本 Learun-ADMS-Ultimate V7.0.0 数字化智慧校园(http://www.learun.cn)  
 * Copyright (c) 2013-2018 北京泉江科技有限公司  
 * 创建人：超级管理员 
 * 日  期：2019-10-17 17:22 
 * 描  述：资产盘点明细表 
 */
(function () {
    var begin = '';
    var end = '';
    var multipleData = null;
    var keyValue = '';
    var page = {
        grid: null,
        init: function ($page, param) {
            $.ajax({
                url: config.webapi + "weixinapi/getweixinwebaccess_token?url=" + encodeURIComponent(window.location.href),
                type: "get",
                success: function (res) {
                    wx.config({
                        debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
                        appId: res.data.appid, // 必填，公众号的唯一标识
                        timestamp: res.data.timestamp, // 必填，生成签名的时间戳
                        nonceStr: res.data.noncestr, // 必填，生成签名的随机串
                        signature: res.data.certificate, // 必填，签名
                        jsApiList: ["scanQRCode"] // 必填，需要使用的JS接口列表
                    });
                }
            });
            keyValue = param.keyValue;
            begin = '';
            end = '';
            multipleData = null;
            page.grid = $page.find('#lr_AssetManagementSystemInventoryItem_list').lrpagination({
                lclass: page.lclass,
                rows: 10, // 每页行数 
                getData: function (param, callback) { // 获取数据 param 分页参数,callback 异步回调 
                    param.multipleData = multipleData;
                    page.loadData(param, callback, $page);
                },
                renderData: function (_index, _item, _$item) { // 渲染数据模板 
                    return page.rowRender(_index, _item, _$item, $page);
                },
                click: function (item, $item, $et) { // 列表行点击事件 
                    if ($et.hasClass('lr-btn-danger')) {
                        page.btnClick(item, $item, $page);
                    } else {
                        page.rowClick(item, $item, $page);
                    }
                },
                btns: page.rowBtns
            });

            //扫码

            $page.find('#lr_AssetManagementSystemInventoryItem_btn').on('tap', function () {

                //learun.nav.go({
                //    path: 'AssetManagementSystem/Ass_InventoryResult/Ass_InventoryItemList/form',
                //    title: '实盘结果录入',
                //    type: 'right',
                //    param: {
                //        acode: "DeskTop_dell3554_1"
                //    }
                //});

                var ua = navigator.userAgent.toLowerCase();
                if (/(html5plus)/i.test(ua)) {
                    //if (false) {
                    $('.bcidBox').css('display', 'block');
                    var scan = new plus.barcode.Barcode('bcid');
                    scan.onmarked = function onmarked(type, result) {
                        scan.close();
                        $('.bcidBox').css('display', 'none');

                        learun.httpget(config.webapi + 'learun/AssetManagementSystem/InventoryItem/formbycode', res.resultStr, (data) => {
                            if (data.Ass_InventoryItemApply) {
                                learun.nav.go({
                                    path: 'AssetManagementSystem/Ass_InventoryResult/Ass_InventoryItemList/form',
                                    title: '实盘结果录入',
                                    type: 'right',
                                    param: {
                                        acode: result
                                    }
                                });
                            } else {
                                learun.layer.warning("未匹配");

                            }
                        });
                    };
                    scan.start();
                } else if (/micromessenger/.test(ua)) {
                    //扫码盘点
                    wx.scanQRCode({
                        needResult: 1, // 默认为0，扫描结果由微信处理，1则直接返回扫描结果，
                        scanType: ["qrCode", "barCode"], // 可以指定扫二维码还是一维码，默认二者都有
                        success: function (res) {
                            learun.httpget(config.webapi + 'learun/AssetManagementSystem/InventoryItem/formbycode', res.resultStr, (data) => {
                                if (data.Ass_InventoryItemApply) {
                                    learun.nav.go({
                                        path: 'AssetManagementSystem/Ass_InventoryResult/Ass_InventoryItemList/form',
                                        title: '实盘结果录入',
                                        type: 'right',
                                        param: {
                                            acode: res.resultStr
                                        }
                                    });
                                } else {
                                    learun.layer.warning("未匹配");

                                }
                            });
                        }
                    });

                } else {
                    learun.layer.warning('请下载app或者到微信浏览器打开网页');
                }
            });
        },
        lclass: 'lr-list',
        loadData: function (param, callback, $page) { // 列表加载后台数据 
            var _postParam = {
                pagination: {
                    rows: param.rows,
                    page: param.page,
                    sidx: 'AAIId',
                    sord: 'DESC'
                },
                queryJson: '{}'
            };
            if (param.multipleData) {
                _postParam.queryJson = JSON.stringify(multipleData);
            }
            if (param.begin && param.end) {
                _postParam.queryJson = JSON.stringify({
                    StartTime: param.begin,
                    EndTime: param.end
                });
            }
            if (keyValue) {
                _postParam.queryJson = JSON.stringify({
                    AAId: keyValue
                });
            }
            learun.httpget(config.webapi + 'learun/AssetManagementSystem/InventoryItem/pagelist', _postParam, (data) => {
                $page.find('.lr-badge').text('0');
                if (data) {
                    $page.find('.lr-badge').text(data.records);
                    callback(data.rows, parseInt(data.records));
                } else {
                    callback([], 0);
                }
            });
        },
        rowRender: function (_index, _item, _$item, $page) { // 渲染列表行数据 
            _$item.addClass('lr-list-item lr-list-item-multi');
            //_$item.append($('<p class="lr-ellipsis"><span>编号:</span></p>').dataFormatter({ value: _item.AAIId }));
            //_$item.append($('<p class="lr-ellipsis"><span>盘点单号:</span></p>').dataFormatter({ value: _item.AAId }));
            _$item.append($('<p class="lr-ellipsis"><span>资产编号:</span></p>').dataFormatter({
                value: _item.AAICode
            }));
            _$item.append($('<p class="lr-ellipsis"><span>名字:</span></p>').dataFormatter({
                value: _item.AAIName
            }));
            _$item.append($('<p class="lr-ellipsis"><span>资产类别:</span></p>').dataFormatter({
                value: _item.AAITId,
                type: 'dataSource',
                code: 'Ass_AssetsType',
                keyId: 'atid',
                text: 'aname'
            }));
            _$item.append($('<p class="lr-ellipsis"><span>资产英文名:</span></p>').dataFormatter({
                value: _item.AAIEName
            }));
            _$item.append($('<p class="lr-ellipsis"><span>是否盘点:</span></p>').dataFormatter({
                value: _item.AISCHECK,
                type: 'dataItem',
                code: 'YesOrNoBit'
            }));
            return '';
        },
        rowClick: function (item, $item, $page) { // 列表行点击触发方法 
            learun.nav.go({
                path: 'AssetManagementSystem/Ass_InventoryResult/Ass_InventoryItemList/form',
                title: '实盘结果录入',
                type: 'right',
                param: {
                    keyValue: item.AAIId
                }
            });
        },
        btnClick: function (item, $item, $page) { // 左滑按钮点击事件 
            learun.layer.confirm('确定要删除该笔数据吗？', function (_index) {
                if (_index === '1') {
                    learun.layer.loading(true, '正在删除该笔数据');
                    learun.httppost(config.webapi + 'learun/AssetManagementSystem/InventoryItem/delete', item.AAIId, (data) => {
                        if (data) { // 删除数据成功 
                            page.grid.reload();
                        }
                        learun.layer.loading(false);
                    });
                }
            }, 'Learun智慧校园提示', ['取消', '确定']);
        },
        rowBtns: ['<a class="lr-btn-danger">删除</a>'] // 列表行左滑按钮 
    };
    return page;
})();
